/*
 * Main.fx
 *
 * @author Dmitry Danileyko
 *
 * Created on 26.11.2009, 21:58:21
 */

package com.pcworld.chineseplayer;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.stage.StageStyle;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.Group;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Arc;
import javafx.scene.shape.ArcType;
import javafx.scene.effect.Lighting;
import javafx.scene.effect.light.DistantLight;
import javafx.scene.shape.Polyline;
import javafx.scene.effect.DropShadow;
import javafx.scene.shape.Line;
import javafx.scene.control.ListView;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;

/**
 * @author Dmitry Danileyko
 */
var fileList : String[];
var playPause : Boolean = true;
var beginPointX : Number;
var beginPointY : Number;

var player : Group = new Group();
var display : Rectangle = new Rectangle();
var case : Rectangle = new Rectangle();
var buttonPlay : Circle = new Circle();
var buttonPrev : Arc = new Arc();
var buttonNext : Arc = new Arc();
var polylinePlay : Polyline = new Polyline();
var groupPause : Group = new Group();
var groupNext : Group = new Group();
var groupPrev : Group = new Group();
var groupX : Group = new Group();
var group_ : Group = new Group();
var listviewPlaylist : ListView = new ListView();
var mediaplayer : MediaView = new MediaView();

var stage : Stage = Stage {
    title: "Китаский плеир"
    width: 600
    height: 500
    style: StageStyle.TRANSPARENT

    scene: Scene {
        fill: Color.TRANSPARENT
        content: [
            player = Group {
                content: [
                    case = Rectangle {
                        x: 50, y: 50
                        width: 450, height: 150
                        fill: Color.rgb(5, 5, 5)
                        arcHeight:150
                        arcWidth:80
                        stroke:Color.DARKRED
                        strokeWidth:15
                        effect: Lighting {
                            diffuseConstant:1.5
                            light: DistantLight {
                                azimuth: -135
                            }
                            surfaceScale: 4
                            specularConstant:0.1
                        }
                        onMouseEntered: function(evt: MouseEvent): Void {
                            listviewPlaylist.visible = true
                        }
                        onMouseExited: function(evt: MouseEvent): Void {
                            listviewPlaylist.visible = false
                        }
                        onMousePressed: function( e: MouseEvent ):Void {
                            beginPointX = e.screenX - stage.x;
                            beginPointY = e.screenY - stage.y;
                        }
                        onMouseDragged: function( e: MouseEvent ):Void {
                            stage.x = e.screenX - beginPointX;
                            stage.y = e.screenY - beginPointY;
                        }

                    },
                    display = Rectangle {
                        width: 170, height: 100
                        fill: Color.GREY
                        stroke: Color.GREY
                        layoutX: bind (case.width - display.layoutBounds.width) / 2 + case.y
                        layoutY: bind (case.height - display.layoutBounds.height) / 2 + case.x
                        effect: Lighting {
                            diffuseConstant:0.5
                            light: DistantLight {
                                azimuth: 135
                            }
                            surfaceScale: 1
                            specularConstant:0.1
                        }
                    },
                    buttonPlay = Circle {
                        radius: 50
                        fill: Color.DARKRED
                        centerY: bind case.height / 2 + case.y
                        centerX: bind display.layoutX - 70
                        effect: Lighting {
                            diffuseConstant:1.5
                            light: DistantLight {
                                azimuth: -135
                            }
                            surfaceScale: 1
                            specularConstant:0.5
                        }
                    },
                    polylinePlay = Polyline {
                        visible: bind playPause
                        points : [ buttonPlay.centerX - 20,buttonPlay.centerY - 30,
                                   buttonPlay.centerX + 30,buttonPlay.centerY,
                                   buttonPlay.centerX - 20,buttonPlay.centerY + 30,
                                   buttonPlay.centerX - 20,buttonPlay.centerY - 30 ]
                        strokeWidth: 1.0
                        stroke: Color.GREY
                        fill:Color.WHITE
                        effect: DropShadow {
                            offsetY: 4
                        }

                    },
                    groupPause = Group {
                        layoutX: bind buttonPlay.centerX - groupPause.layoutBounds.width / 2
                        layoutY: bind buttonPlay.centerY - groupPause.layoutBounds.height / 2
                        content: [
                            Rectangle {
                                width: 10, height: 50
                                stroke: Color.GREY
                                strokeWidth: 1.0
                                fill:Color.WHITE
                            },
                            Rectangle {
                                x: 20, y: 0
                                width: 10, height: 50
                                stroke: Color.GREY
                                strokeWidth: 1.0
                                fill:Color.WHITE
                            }
                        ]
                        effect: DropShadow {
                            offsetY: 4
                        }
                        visible: bind not playPause
                    },
                    buttonPrev = Arc {
                        centerX: bind display.layoutX + display.width + 70, centerY: bind case.arcHeight / 2 + case.x
                        radiusX: 50, radiusY: 50
                        startAngle: 90
                        length: 180
                        type: ArcType.CHORD
                        fill: Color.GREEN
                        effect: Lighting {
                            diffuseConstant:1.5
                            light: DistantLight {
                                azimuth: -135
                            }
                            surfaceScale: 1
                        }
                    },
                    groupPrev = Group {
                        layoutX: bind buttonPrev.centerX - groupPrev.layoutBounds.width / 2
                        layoutY: bind buttonPrev.centerY - groupPrev.layoutBounds.height / 2
                        content: [
                            Polyline {
                                stroke: Color.GREY
                                points : [-5,0, -20,25, -5,50, -5,0 ]
                                strokeWidth: 1.0
                                fill:Color.WHITE
                            },
                            Polyline {
                                stroke: Color.GREY
                                points : [15,0, 0,25, 15,50, 15,0 ]
                                strokeWidth: 1.0
                                fill:Color.WHITE
                            },
                        ]
                        effect: DropShadow { 
                            offsetY: 4
                        }
                    },
                    buttonNext = Arc {
                        centerX: bind display.layoutX + display.width + 70, centerY: bind case.arcHeight / 2 + case.x
                        radiusX: 50, radiusY: 50
                        startAngle: 270,
                        length: 180
                        type: ArcType.OPEN
                        fill: Color.BLUE
                        stroke: Color.BLUE
                        effect: Lighting {
                            diffuseConstant:1.5
                            light: DistantLight { 
                                azimuth: -135
                            }
                            surfaceScale: 1
                        }
                    },
                    groupNext = Group {
                        layoutX: bind buttonNext.centerX - groupNext.layoutBounds.width / 2
                        layoutY: bind buttonNext.centerY - groupNext.layoutBounds.height / 2
                        content: [
                            Polyline {
                                points : [42,0, 57,25, 42,50, 42,0 ]
                                strokeWidth: 1.0
                                stroke: Color.GREY
                                fill:Color.WHITE
                            },
                            Polyline {
                                points : [22,0, 37,25, 22,50, 22,0 ]
                                strokeWidth: 1.0
                                stroke: Color.GREY
                                fill:Color.WHITE
                            },
                        ]
                        effect: DropShadow { 
                            offsetY: 4
                        }
                    },
                    groupX = Group {                                                
                        layoutX: bind case.layoutBounds.width - 39
                        layoutY: bind case.layoutBounds.minY - 26
                        content: [
                            Rectangle {
                                arcHeight:8
                                arcWidth:8
                                x: 10, y: 10
                                width: 20, height: 20
                                stroke:Color.GREY
                                fill:Color.DARKRED
                                onMouseClicked: function(evt: MouseEvent): Void {
                                    if ((evt.clickCount == 1) and (evt.button == MouseButton.PRIMARY)) then {
                                        FX.exit();
                                    }
                                }
                            },
                            Line {
                                startX: 13, startY: 13
                                endX: 27, endY: 27
                                strokeWidth: 1
                                stroke: Color.WHITE
                            },
                            Line {
                                startX: 13, startY: 27
                                endX: 27, endY: 13
                                strokeWidth: 1
                                stroke: Color.WHITE
                            }

                        ]
                    },
                    group_ = Group {                                                
                        layoutX: bind case.layoutBounds.width - 60
                        layoutY: bind case.layoutBounds.minY - 26
                        content: [
                            Rectangle {
                                arcHeight:8
                                arcWidth:8
                                x: 10, y: 10
                                width: 20, height: 20
                                stroke:Color.GREY
                                fill: Color.DARKRED
                                onMouseClicked: function(evt: MouseEvent): Void {
                                    if ((evt.clickCount == 1) and (evt.button == MouseButton.PRIMARY)) then {
                                        stage.iconified = true
                                    }
                                }
                            },
                            Line {
                                startX: 14, startY: 23
                                endX: 26, endY: 23
                                strokeWidth: 1
                                stroke: Color.WHITE
                            }
                        ]
                    },
                    listviewPlaylist = ListView {
                        width: 300
                        height: 200
                        layoutY: bind case.layoutBounds.maxY - 3
                        layoutX: bind (case.width - listviewPlaylist.layoutBounds.width) / 2  + case.y
                        onMouseEntered: function(evt: MouseEvent): Void {
                            listviewPlaylist.visible = true
                        }
                        onMouseExited: function(evt: MouseEvent): Void {
                            listviewPlaylist.visible = false
                        }
                        items: bind fileList
                    },
                    mediaplayer = MediaView {
                        mediaPlayer : MediaPlayer {
                            media : Media {
                            }
                        }
                    }
                ]
            }
        ]
    }
}